zoukankan      html  css  js  c++  java
  • Palindrome

    title: HDU - 1513 

    A palindrome is a symmetrical string, that is, a string read identically from left to right as well as from right to left. You are to write a program which, given a string, determines the minimal number of characters to be inserted into the string in order to obtain a palindrome. 

    As an example, by inserting 2 characters, the string "Ab3bd" can be transformed into a palindrome ("dAb3bAd" or "Adb3bdA"). However, inserting fewer than 2 characters does not produce a palindrome.

    InputYour program is to read from standard input. The first line contains one integer: the length of the input string N, 3 <= N <= 5000. The second line contains one string with length N. The string is formed from uppercase letters from 'A' to 'Z', lowercase letters from 'a' to 'z' and digits from '0' to '9'. Uppercase and lowercase letters are to be considered distinct. 
    OutputYour program is to write to standard output. The first line contains one integer, which is the desired minimal number. 
    Sample Input

    5
    Ab3bd

    Sample Output

    2
    题意:给你一个字符串,问你最少需要增加几个字符才能使字符串变成回文串,题目很容易理解,而且之前在集训的时候有看过这种题目,但是因为自己的懒散,就没有及时补题,补题和写博客还是很重要啊!!!
    分析:题目要求插入最少的字符数量,那我们就只需要求题目给出的字符串和其反向字符串的最长公共子序列,最后用字符串的长度减去最长公共子序列的长度就是要求的答案了!还有一个问题就是题目给出N的最大值为5000,但是开不了一个5000*5000的数组啊!那怎么办呢?使用滚动数组,每一个要求的答案都只与当前行和前一行有关,所以后面的覆盖前面的不会对最终结果造成影响,所以最终其实只需要两行,分奇偶进行存储就好了!
    AC代码:
    #include<iostream>
    #include<cstring>
    #include<cmath>
    #define N 5050
    typedef long long ll;
    using namespace std;
    char a[N],b[N];
    int dp[10][N];
    int Max(int x,int y)
    {
        return x>y?x:y;
    }
    int main()
    {
        int n;
        while (cin>>n)
        {
              for (int i=0;i<n;i++)
                cin>>a[i];
              memset(dp,0,sizeof(dp));
              for (int i=1;i<=n;i++)
                for (int j=1;j<=n;j++)
               {
                   if (a[i-1]==a[n-j])
                     dp[i%2][j]=dp[(i-1)%2][j-1]+1;
                   else if (a[i-1]!=a[n-j])
                     dp[i%2][j]=Max(dp[i%2][j-1],dp[(i-1)%2][j]);
               }
               cout << n-dp[n%2][n] << endl;
        }
    
        return 0;
    }
  • 相关阅读:
    go 接收发送文件
    【0031】反转整数/判断回文
    【003】链表或字符串的【反转】【左旋转】
    【002】链表或字符串模拟加法/加一/乘法
    【01】数组中只出现一次的数字
    【面试题050】树中两个结点的最低公共祖先
    【面试题049】把字符串转换成整数
    【面试题048】不能继承的类
    【面试题047】不用加减乘除做加法
    【面试题046】求1+2+...+n
  • 原文地址:https://www.cnblogs.com/lisijie/p/7966609.html
Copyright © 2011-2022 走看看